#Compile Exe
#Dim All

'--------------------------------------------------------------------------------
'   ** Includes **
'--------------------------------------------------------------------------------
#If Not %Def(%WINAPI)
    #Include "WIN32API.INC"
#EndIf
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Constants **
'--------------------------------------------------------------------------------
%IDD_DIALOG1            = 101
%IDR_MENU1              = 102
%IDM_FILE_OPEN          = 1001
%IDR_ACCELERATOR1       = 103
%IDM_FILE_SAVE          = 1002
%IDM_FILE_EXIT          = 1003
%IDM_EDIT_CUT           = 1004
%IDM_EDIT_COPY          = 1005
%IDM_EDIT_PASTE         = 1006
%IDM_HELP_HELPTOPICS    = 1007
%IDM_HELP_ABOUT         = 1008
%IDM_EDIT_SUB_COOL      = 1009
%IDM_EDIT_SUB_DARE      = 1010

'These constants help define the menu structure
%ODM_BASE_MENUBAR_ITEM_ID = 9000  'This is the ID threshold for top level menubar items
%ODM_BASE_SUBMENU_ITEM_ID = 2000  'This is the ID threshold for any (sub-)menu items that contain sub-menus
%ODM_MAX_STRING           = 40    'Number of bytes for ASCIIZ menu strings

%ODM_ACCEL_KEY_SPACING     = 10   'Seems to work good
%ODM_ICON_IN_MENU_WIDTH    = 16   '16 for icon
%ODM_MARGIN_SPACING        = 4
%ODM_TEXT_OFFSET_FROM_ICON = 2    'Add spacing between sub-menu item's text and icon

'These constants enumerate the different possible Windows OS platforms
%WinUnknown      = 0
%Win95           = 1
%Win98           = 2
%WinME           = 3
%WinNT           = 4
%Win2K           = 5
%WinXP           = 6
%WinDotNetServer = 7
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Types **
'--------------------------------------------------------------------------------
'NOTE: hIco is the default icon image to display.  If you want to display checked/unchecked states,
'  hIco        = unchecked state icon  (could be NULL for no image)
'  hCheckedIco = checked state icon    (can be the same as hIco too)
'NOTE: wID **MUST** be the first item in the TYPE.
Type MenuItemType
   wID         As Dword  'Menu item's control ID
   zTxt        As Asciiz * %ODM_MAX_STRING
   hIco        As Dword  'Default icon image
   hCheckedIco As Dword  'Checked icon image
   AccelWidth  As Long   'Holds TextExtent of any accelerator key text
End Type

Type ColorSet
   BkFace            As Long  'Color for raised button face
   BkFaceSunken      As Long  'Color for depressed button face
   BkHighlight       As Long  'Color for sub-menu highlighted items
   BkHighlightSunken As Long  'Color for depressed face on sub-menu higlighted items
   BkFocusHighlight  As Long  'Color for focus highlighting top level menu bar
   BkFocusSelect     As Long  'Color for selected top level menu bar item
   TxDefault         As Long  'Default color for text
   TxGrayed          As Long  'Color for grayed text
   TxHighlighted     As Long  'Color for highlighted text
End Type
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Globals **
'--------------------------------------------------------------------------------
Global GetColorFor()      As ColorSet
Global CurrentDisplayMode As Long
Global OSVersion          As Long
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Declarations **
'--------------------------------------------------------------------------------
Declare Function AttachMENU1(ByVal hDlg As Dword) As Dword
Declare Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd _
    As Word, ByVal byFVirt As Byte) As Long
Declare Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword
Declare CallBack Function ShowDIALOG1Proc()
Declare Function ShowDIALOG1(ByVal hParent As Dword) As Long
Declare Function GetWindowsVersion() As Long
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** PBMAIN **
'--------------------------------------------------------------------------------
Function PBMain()

    Local dm As DEVMODE
    Local OSVO As OSVersionInfo
    Dim GetColorFor( 1)

    'Get Current OS Version
    'Note: You can force a behavior style by explicitly assigning an equate to OSVersion
    OSVersion = GetWindowsVersion()  '%WinXP

    'Set colors for 256 color mode
    GetColorFor(0).BkFace            = RGB( 128, 128, 0)
    GetColorFor(0).BkFaceSunken      = RGB( 128, 128, 0) '%YELLOW does not make good 3D effect
    GetColorFor(0).BkHighlight       = RGB( 128, 0, 0)
    GetColorFor(0).BkHighlightSunken = RGB( 128, 0, 0)   '%RED does not make good 3D effect
    Select Case As Long OSVersion
       Case %WinXP
          GetColorFor(0).BkFocusHighlight  = GetColorFor(0).BkHighlight
          GetColorFor(0).BkFocusSelect     = GetColorFor(0).BkFaceSunken
       Case Else
          GetColorFor(0).BkFocusHighlight  = GetColorFor(0).BkHighlight
          GetColorFor(0).BkFocusSelect     = GetColorFor(0).BkHighlight
    End Select
    GetColorFor(0).TxDefault         = GetSysColor( %COLOR_MENUTEXT)
    GetColorFor(0).TxGrayed          = &H00505050  'Dark Gray
    GetColorFor(0).TxHighlighted     = GetSysColor( %COLOR_HIGHLIGHTTEXT) 'To match the sub-menu arrow graphic

    'Set colors for 16 bit/High Color or better
    GetColorFor(1).BkFace            = RGB( 200, 200, 152)
    GetColorFor(1).BkFaceSunken      = RGB( 220, 220, 188)
    GetColorFor(1).BkHighlight       = RGB( 173, 173, 101)
    GetColorFor(1).BkHighlightSunken = RGB( 187, 187, 128)
    Select Case As Long OSVersion
       Case %WinXP
          GetColorFor(1).BkFocusHighlight  = RGB(159, 220, 133)
          GetColorFor(1).BkFocusSelect     = GetColorFor(1).BkFaceSunken
       Case Else
          GetColorFor(1).BkFocusHighlight  = GetColorFor(1).BkHighlight
          GetColorFor(1).BkFocusSelect     = GetColorFor(1).BkHighlight
    End Select
    GetColorFor(1).TxDefault         = GetSysColor( %COLOR_MENUTEXT)
    GetColorFor(1).TxGrayed          = GetSysColor( %COLOR_GRAYTEXT)
    GetColorFor(1).TxHighlighted     = GetSysColor( %COLOR_HIGHLIGHTTEXT) 'To match the sub-menu arrow graphic

    'Get Current Display Mode
    dm.dmSize = Len( DEVMODE)
    EnumDisplaySettings ByVal 0, %ENUM_CURRENT_SETTINGS, dm
    CurrentDisplayMode = IIf&( dm.dmBitsPerPel > 8, 1, 0)

    ShowDIALOG1 %HWND_DESKTOP

End Function
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Macros **
'--------------------------------------------------------------------------------
'The following MACROS were added for coding clarity in the ShowDIALOG1Proc function
Macro mHighlightMenuItem

        GetWindowRect CbHndl, tRect
        tRect.nBottom = FocusRect.nBottom - tRect.nTop
        tRect.nTop    = FocusRect.nTop    - tRect.nTop
        tRect.nRight  = FocusRect.nRight  - tRect.nLeft
        tRect.nLeft   = FocusRect.nLeft   - tRect.nLeft
        hDC = GetWindowDC( CbHndl)
        'Draw
        Select Case As Long OSVersion
           Case %WinXP
              'Calculate a darker shade of the focus color for the frame
              I = GetColorFor( CurrentDisplayMode).BkFocusHighlight
              !xor edx, edx  'clear edx
              !mov eax, I
              !shr eax, 18   'divide blue value by 4
              !mov dl, al
              !shl edx, 16
              !mov eax, I
              !shr ah, 2     'divide green value by 4
              !shr al, 2     'divide blue value by 4
              !mov dx, ax
              !mov I, edx
              hf = SelectObject( hDC, CreatePen( %PS_SOLID, 0, I))
              'Draw frame using custom colored pen
              MoveToEx hDC, tRect.nLeft, tRect.nTop, ByVal 0
              LineTo hDC, tRect.nRight-1, tRect.nTop
              LineTo hDC, tRect.nRight-1, tRect.nBottom-1
              LineTo hDC, tRect.nLeft, tRect.nBottom-1
              LineTo hDC, tRect.nLeft, tRect.nTop

              DeleteObject SelectObject( hDC, CreatePen( %PS_SOLID, 0, GetColorFor( CurrentDisplayMode).BkFocusHighlight))
              For I = 1 To ((tRect.nBottom - tRect.nTop) * (tRect.nRight - tRect.nLeft)) \ 2
                 Do
                    pt.x = Rnd( tRect.nLeft+1, tRect.nRight-1)
                 Loop Until pt.x Mod 2
                 Do
                    pt.y = Rnd( tRect.nTop+1, tRect.nBottom-1)
                 Loop Until pt.y Mod 2
                 MoveToEx hDC, pt.x, pt.y, ByVal 0
                 LineTo hDC, pt.x+1, pt.y
              Next
              DeleteObject SelectObject( hDC, hf)

              SetTextColor hDC, GetColorFor( CurrentDisplayMode).TxDefault
              SetBkMode hDC, %TRANSPARENT

              strMenu = MenuItemData( Offset-1).zTxt

              If Len( strMenu) <> 0 Then
                 ncm.cbSize = Len( NONCLIENTMETRICS)
                 SystemParametersInfo %SPI_GETNONCLIENTMETRICS, SizeOf( ncm), ByVal VarPtr(ncm), 0
                 If Len(ncm.lfMenuFont) Then
                    hf = CreateFontIndirect(ncm.lfMenuFont)
                    If hf Then hf = SelectObject(hDC, hf)
                 End If
                 t2Rect = tRect
                 'Adjust for offset
                 Decr t2Rect.nTop
                 Decr t2Rect.nBottom
                 If MenuItemData( Offset-1).hIco Then
                    t2Rect.nLeft = t2Rect.nLeft + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING\2 - 2  'Leave room for icons
                 Else
                    'When no icon in top level, adjust RECT
                    t2Rect.nLeft = t2Rect.nLeft - 2
                 End If
                 DrawText hDC, ByVal StrPtr(strMenu), Len(strMenu), t2Rect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER Or %DT_CENTER
                 If hf Then DeleteObject SelectObject(hDC, hf)
              End If
           Case %Win98
              DrawEdge hDC, tRect, %BDR_RAISEDOUTER, %BF_RECT
           Case Else 'WinME, WinNT, Win2k --- I'm not sure what the standard focus highlighting is for these OSes
              DrawEdge hDC, tRect, %BDR_RAISEDOUTER, %BF_RECT
        End Select
        If hIcon Then DrawIconEx hDC, tRect.nLeft + %ODM_MARGIN_SPACING - 2, tRect.nTop + 1, hIcon, 16, 16, 0, ByVal 0, %DI_NORMAL
        ReleaseDC CbHndl, hDC

End Macro

Macro mRestoreMenuItem

        GetWindowRect CbHndl, tRect
        tRect.nBottom = FocusRect.nBottom - tRect.nTop
        tRect.nTop    = FocusRect.nTop    - tRect.nTop
        tRect.nRight  = FocusRect.nRight  - tRect.nLeft
        tRect.nLeft   = FocusRect.nLeft   - tRect.nLeft
        hDC = GetWindowDC( CbHndl)
        'Erase
        Select Case As Long OSVersion
           Case %WinXP
              FillRect hDC, tRect, hCustomBrush

              SetTextColor hDC, GetColorFor( CurrentDisplayMode).TxDefault
              SetBkMode hDC, %TRANSPARENT

              strMenu = MenuItemData( Offset-1).zTxt

              If Len( strMenu) <> 0 Then
                 ncm.cbSize = Len( NONCLIENTMETRICS)
                 SystemParametersInfo %SPI_GETNONCLIENTMETRICS, SizeOf( ncm), ByVal VarPtr(ncm), 0
                 If Len(ncm.lfMenuFont) Then
                    hf = CreateFontIndirect(ncm.lfMenuFont)
                    If hf Then hf = SelectObject(hDC, hf)
                 End If
                 t2Rect = tRect
                 'Adjust for offset
                 Decr t2Rect.nTop
                 Decr t2Rect.nBottom
                 If MenuItemData( Offset-1).hIco Then
                    t2Rect.nLeft = t2Rect.nLeft + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING\2 - 2  'Leave room for icons
                 Else
                    'When no icon in top level, adjust RECT
                    t2Rect.nLeft = t2Rect.nLeft - 2
                 End If
                 DrawText hDC, ByVal StrPtr(strMenu), Len(strMenu), t2Rect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER Or %DT_CENTER
                 If hf Then DeleteObject SelectObject(hDC, hf)
              End If
           Case %Win98
              FrameRect hDC, tRect, hCustomBrush
           Case Else  'WinME, WinNT, Win2k --- I'm not sure what the standard focus highlighting is for these OSes
              FrameRect hDC, tRect, hCustomBrush
        End Select
        'Redraw icon in case it overlapped the button frame
        If hIcon Then DrawIconEx hDC, tRect.nLeft + %ODM_MARGIN_SPACING - 2, tRect.nTop + 1, hIcon, 16, 16, 0, ByVal 0, %DI_NORMAL
        ReleaseDC CbHndl, hDC

End Macro
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Menus **
'--------------------------------------------------------------------------------
Function AttachMENU1(ByVal hDlg As Dword) As Dword

    Local hMenu As Long
    Local hPopUp1 As Long
    Local hPopUp2 As Long
    Local hPopUp3 As Long

    Menu New Bar To hMenu
    Menu New PopUp To hPopUp1
    Menu Add PopUp, hMenu, "Super Fabulous &File Menu", hPopUp1, %MF_ENABLED
        Menu Add String, hPopUp1, "&Open" + $Tab + "Ctrl+O", %IDM_FILE_OPEN, _
            %MF_ENABLED
        Menu Add String, hPopUp1, "&Save" + $Tab + "Ctrl+S", %IDM_FILE_SAVE, _
            %MF_ENABLED
        Menu Add String, hPopUp1, "-", 0, 0
        Menu Add String, hPopUp1, "&Exit" + $Tab + "Ctrl+E", %IDM_FILE_EXIT, _
            %MF_ENABLED
    Menu New PopUp To hPopUp1
    Menu Add PopUp, hMenu, "&Edit", hPopUp1, %MF_ENABLED
        Menu Add String, hPopUp1, "C&ut" + $Tab + "Ctrl+X", %IDM_EDIT_CUT, _
            %MF_ENABLED
        Menu Add String, hPopUp1, "&Copy" + $Tab + "Ctrl+C", %IDM_EDIT_COPY, _
            %MF_ENABLED
        Menu Add String, hPopUp1, "&Paste" + $Tab + "Ctrl+V", %IDM_EDIT_PASTE, _
            %MF_GRAYED
        Menu Add String, hPopUp1, "-", 0, 0
        Menu New PopUp To hPopUp2
        Menu Add PopUp, hPopUp1, "&Sub-Menu Test", hPopUp2, %MF_ENABLED
           Menu Add String, hPopUp2, "&Cool", %IDM_EDIT_SUB_COOL, _
               %MF_ENABLED
           Menu Add String, hPopUp2, "-", 0, 0
           Menu New PopUp To hPopUp3
           Menu Add PopUp, hPopUp2, "Double &Nested Test", hPopUp3, %MF_ENABLED
              Menu Add String, hPopUp3, "&Dare to Dream" + $Tab + "Ctrl+D", %IDM_EDIT_SUB_DARE, _
                  %MF_ENABLED
    Menu New PopUp To hPopUp1
    Menu Add PopUp, hMenu, "&Help", hPopUp1, %MF_ENABLED
        Menu Add String, hPopUp1, "&Help Topics" + $Tab + "F1", _
            %IDM_HELP_HELPTOPICS, %MF_ENABLED
        Menu Add String, hPopUp1, "&About" + $Tab + "Ctrl+A", %IDM_HELP_ABOUT, _
            %MF_ENABLED

    Menu Attach hMenu, hDlg

    Function = hMenu

End Function
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Accelerators **
'
' No code was modified for accelerators.  This is straight out of PBForms
'--------------------------------------------------------------------------------
Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd As Word, _
    ByVal byFVirt As Byte) As Long
    tAccel.fVirt = byFVirt
    tAccel.key = wKey
    tAccel.cmd = wCmd
End Function

Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword

    Local hAccel As Dword
    Local tAccel() As ACCELAPI
    Dim tAccel(1 To 9)

    AssignAccel tAccel(1), Asc("O"), %IDM_FILE_OPEN, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(2), Asc("S"), %IDM_FILE_SAVE, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(3), Asc("E"), %IDM_FILE_EXIT, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(4), Asc("X"), %IDM_EDIT_CUT, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(5), Asc("C"), %IDM_EDIT_COPY, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(6), Asc("V"), %IDM_EDIT_PASTE, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(7), %VK_F1, %IDM_HELP_HELPTOPICS, %FVIRTKEY Or %FNOINVERT
    AssignAccel tAccel(8), Asc("A"), %IDM_HELP_ABOUT, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT
    AssignAccel tAccel(9), Asc("D"), %IDM_EDIT_SUB_DARE, %FVIRTKEY Or %FCONTROL Or _
        %FNOINVERT

    Accel Attach hDlg, tAccel() To hAccel

    Function = hAccel

End Function
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Support Procs **
'--------------------------------------------------------------------------------
Function GetWindowsVersion() As Long
   'This function courtesy of Scott Turchin.  I've modified it for this code.
   'Original posting can be found here:
   'http://www.powerbasic.com/support/forums/Forum4/HTML/002310.html

   Local osinfo   As OSVERSIONINFO

   osinfo.dwOsVersionInfoSize = SizeOf(osinfo)

   If IsFalse GetVersionEx( osinfo) Then Exit Function ' Function = %WinUnknown

   If osinfo.dwPlatformId = %VER_PLATFORM_WIN32_NT Then
      Select Case As Long osinfo.dwMajorVersion
         Case < 5
            Function = %WinNT
         Case 5
            Select Case As Long osinfo.dwMinorVersion
               Case 0
                  Function = %Win2K
               Case 1
                  Function = %WinXP
               Case 2
                  Function = %WinDotNetServer
            End Select
      End Select
   ElseIf osinfo.dwPlatformId = %VER_PLATFORM_WIN32_WINDOWS Then
      Select Case As Long osinfo.dwMinorVersion
         Case < 10
            Function = %Win95
         Case 10
            Function = %Win98
         Case 90
            Function = %WinME
      End Select
   End If

End Function

Function CountItems( ByVal hMenu As Long) As Long

   Register I As Long, K As Long

   Local hSubMenu As Long

   For K = 0 To GetMenuItemCount( hMenu) - 1
      Incr I  'Count hMenu item...
      hSubMenu = GetSubMenu( hMenu, K)
      If hSubMenu Then I = I + CountItems( hSubMenu) 'Add all nested items for hSubMenu item
   Next

   Function = I

End Function

Sub ModifySubMenu( ByVal hDlg As Long, _                'Handle of dialog
                   ByVal hSubMenu As Long, _            'Handle to sub-menu
                   ByVal ptrMID As MenuItemType Ptr, _  'Pointer to MenuItemData array
                   Offset As Long, _                    'Current subscript for MenuItemData array
                   SubMenuID As Long)                   'Tracks ID# to assign to a sub-menu

   Register I As Long, K As Long

   Local MaxAccelTxtWidth As Long
   Local Result As Long
   Local hf     As Long
   Local hDC    As Long
   Local SizeA  As SizeL
   Local ncm    As NONCLIENTMETRICS
   Local StartingSubMenuOffset As Long
   Local zTxt   As Asciiz * %ODM_MAX_STRING
   Local hNestedMenu As Long

   'Remember where we started...
   StartingSubMenuOffset = Offset + 1

   'Loop through all sub-menu items...
   For I = 0 To GetMenuItemCount( hSubMenu) - 1
      'Determine what the sub-menu item is...
      Result = GetMenuState( hSubMenu, I, %MF_BYPOSITION)
      hNestedMenu = GetSubMenu( hSubMenu, I)

      If hNestedMenu Then
         'Nested sub-menu
         GetMenuString hSubMenu, I, zTxt, SizeOf( zTxt), %MF_BYPOSITION
         Incr Offset
         @ptrMID[ Offset].wID = SubMenuID
         Incr SubMenuID
         @ptrMID[ Offset].zTxt = zTxt
         Select Case As Const$ zTxt
            Case "&Sub-Menu Test"
               @ptrMID[ Offset].hIco = LoadIcon(0, ByVal %IDI_QUESTION)
            Case "Double &Nested Test"
               @ptrMID[ Offset].hIco = LoadIcon(0, ByVal %IDI_HAND)
            Case Else
               'No icons to display
         End Select

         'Change to %MFT_OWNERDRAW
         ModifyMenu hSubMenu, I, (LoByt( LoWrd( Result)) Xor %MF_POPUP) Or %MF_BYPOSITION Or %MF_OWNERDRAW, @ptrMID[ Offset].wID, ByVal 0

         'Set max accelerator ket text width for all sub-menu items up to now...
         For K = StartingSubMenuOffset To Offset
            @ptrMID[ K].AccelWidth = MaxAccelTxtWidth + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING
         Next
         'Modify the nested sub-menu...
         ModifySubMenu hDlg, hNestedMenu, ptrMID, Offset, SubMenuID

         'Start new block...
         StartingSubMenuOffset = Offset + 1
      Else
         If (Result And %MF_SEPARATOR) Then
            'Change %MFT_SEPARATOR to %MFT_OWNERDRAW, maintain ID = 0
            ModifyMenu hSubMenu, I, Result Or %MF_BYPOSITION Or %MF_OWNERDRAW, 0, ByVal 0
         Else
            'Change %MFT_STRING to %MFT_OWNERDRAW, add icons, calculate width of accelerator key text
            GetMenuString hSubMenu, I, zTxt, SizeOf( zTxt), %MF_BYPOSITION
            Incr Offset
            @ptrMID[ Offset].wID = GetMenuItemID( hSubMenu, I)
            @ptrMID[ Offset].zTxt = zTxt
            'Modify the following SELECT CASE as desired to add icons
            'where you want them.  You can also load icons from a resource file
            Select Case As Long @ptrMID[ Offset].wID
               Case %IDM_FILE_OPEN
                  @ptrMID[ Offset].hIco        = LoadIcon(0, ByVal %IDI_EXCLAMATION)
'Leave out checked icon to test default icon
'Uncomment to see custom checked icon
'                  @ptrMID[ Offset].hCheckedIco = LoadIcon(0, BYVAL %IDI_HAND)
               Case %IDM_EDIT_CUT
                  @ptrMID[ Offset].hIco = LoadIcon(0, ByVal %IDI_EXCLAMATION)
               Case %IDM_HELP_ABOUT
                  @ptrMID[ Offset].hIco = LoadIcon(0, ByVal %IDI_APPLICATION)
               Case %IDM_HELP_HELPTOPICS
                  @ptrMID[ Offset].hIco = LoadIcon(0, ByVal %IDI_QUESTION)
               Case Else
                  'No icons to display
            End Select
            'Change %MFT_STRING to %MFT_OWNERDRAW
            ModifyMenu hSubMenu, I, Result Or %MF_BYPOSITION Or %MF_OWNERDRAW, @ptrMID[ Offset].wID, ByVal 0

            'Determine width of accelerator key text
            If InStr( zTxt, $Tab) Then
               zTxt = Parse$( zTxt, $Tab, 2)   'Get accelerator key text
               hDC = GetDC( hDlg)
                  ncm.cbSize = Len( NONCLIENTMETRICS)
                  SystemParametersInfo %SPI_GETNONCLIENTMETRICS, SizeOf( ncm), ByVal VarPtr(ncm), 0
                  If Len(ncm.lfMenuFont) Then
                     hf = CreateFontIndirect(ncm.lfMenuFont)
                     If hf Then hf = SelectObject(hDC, hf)
                  End If
                  GetTextExtentPoint32 hDC, zTxt, Len( zTxt), SizeA
                  If sizeA.cx > MaxAccelTxtWidth Then MaxAccelTxtWidth = sizeA.cx
                  If hf Then DeleteObject SelectObject(hDC, hf)
               ReleaseDC hDlg, hDC
            End If
         End If
      End If
   Next
   'Set max accelerator ket text width for all sub-menu items...
   For I = StartingSubMenuOffset To Offset
      @ptrMID[ I].AccelWidth = MaxAccelTxtWidth + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING
   Next

End Sub
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** CallBacks **
'--------------------------------------------------------------------------------
CallBack Function ShowDIALOG1Proc()

   Register I As Long, K As Long

   Static hCustomBrush         As Long  ' Custom background color
   Static hCustomSunkenBrush   As Long  ' Custom sunken background color (button depression)
   Static hCustomBkBrush       As Long  ' Custom background highlight color
   Static hCustomSunkenBkBrush As Long  ' Custom sunken background highlight color (button depression)
   Static hCustomFocusHLBrush  As Long  ' Custom highlight color for top level menu item
   Static hCustomFocusSelBrush As Long  ' Custom highlight color for selected top level menu item
   Static RightEdge            As Long  ' 'Coordinate' of the dialog's right edge
   Static Border               As Long  ' 'Coordinate' of the right edge of the last top level menubar item
   Static FocusItem            As Long  ' Control ID of the top level menubar item that has focus
   Static hTimer               As Dword ' Handle to Timer
   Static DialogIsActive       As Long  ' Track if dialog is active

   Static MenuItemData()  As MenuItemType  'Maintain info for each ownerdrawn menu item
   'Note:  This is necessary because menu items with fType = %MFT_OWNERDRAW do not
   '       return the dwTypeData correctly.
   'Note:  If you want to have multiple dialogs active concurrently with ownerdrawn menus,
   '       they should have unique dialog callback functions.  Otherwise there will be problems
   '       with the STATIC variables.

   Local Offset                As Long 'General purpose local variable
   Local SubMenuID             As Long
   Local MaxAccelTxtWidth      As Long
   Local StartingSubMenuOffset As Long
   Local FocusRect             As RECT ' Coordinates of the top level menubar item with focus
   Local NewColorMode          As Long

   Local hDC      As Long  'Handles
   Local hMenu    As Long
   Local hSubMenu As Long
   Local hIcon    As Long
   Local hf       As Long

   Local strMenu  As String 'Strings
   Local strMenu2 As String
   Local zTxt     As Asciiz * %ODM_MAX_STRING

   Local tRect    As RECT   'For processing messages
   Local t2Rect   As RECT
   Local ptrRECT  As RECT Ptr
   Local SizeA    As SizeL
   Local ncm      As NONCLIENTMETRICS
   Local mminfo   As MINMAXINFO Ptr
   Local pt       As POINTAPI
   Local lpmis    As MEASUREITEMSTRUCT Ptr
   Local lpdis    As DRAWITEMSTRUCT Ptr

   Select Case CbMsg
       Case %WM_INITDIALOG
           'Initialize var
           DialogIsActive = %True

           'Get starting dimensions for dialog
           GetClientRect CbHndl, tRect
           'Save total width
           RightEdge = tRect.nRight + 4
           hCustomBrush         = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFace)
           hCustomSunkenBrush   = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFaceSunken)
           hCustomBkBrush       = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkHighlight)
           hCustomSunkenBkBrush = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkHighlightSunken)
           hCustomFocusHLBrush  = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFocusHighlight)
           hCustomFocusSelBrush = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFocusSelect)

           hMenu = GetMenu( CbHndl)

           'Count Max# total menu & sub-menu items
           I = CountItems( hMenu)
           'Dimension array for strings and icons
           Dim MenuItemData( I)
           SubMenuID = %ODM_BASE_SUBMENU_ITEM_ID

           'Now we modify our menu to
           '  1) add control ID's to the top level menubar items
           '  2) change all items to ownerdraw

           For K = 0 To GetMenuItemCount( hMenu) - 1
              '--- SUB-MENUS ----------------------
              hSubMenu = GetSubMenu( hMenu, K)
              ModifySubMenu CbHndl, hSubMenu, VarPtr( MenuItemData( 0)), Offset, SubMenuID
              '--- TOP-LEVEL MENUS ----------------------
              GetMenuString hMenu, K, zTxt, SizeOf( zTxt), %MF_BYPOSITION
              Incr Offset
              'Set an ID for top level menubar items
              MenuItemData( Offset).wID  = %ODM_BASE_MENUBAR_ITEM_ID + K
              MenuItemData( Offset).zTxt = zTxt
              'Modify the following SELECT CASE as desired to add icons
              'where you want them.  You can also load icons from a resource file
              Select Case As Long K
                 Case 0  'First menu bar item
'Check spacing on menu item with no icon....
'                    MenuItemData( Offset).hIco = LoadIcon(0, BYVAL %IDI_APPLICATION)
                 Case 1  'Second menu bar item
                    MenuItemData( Offset).hIco = LoadIcon(0, ByVal %IDI_ASTERISK)
                 Case 2  'Third menu bar item
                    MenuItemData( Offset).hIco = LoadIcon(0, ByVal %IDI_WINLOGO)
                 Case Else
                    'No icons to display
              End Select
              ModifyMenu hMenu, K, %MF_BYPOSITION Or %MF_OWNERDRAW, MenuItemData( Offset).wID, ByVal 0
           Next

       Case %WM_GETMINMAXINFO
           mminfo = CbLParam
           'Set the minimum dialog width to avoid incorrect painting of multi-line top level menubar
           @mminfo.ptMinTrackSize.x = Border + 16

       Case %WM_NCACTIVATE
          DialogIsActive = CbWParam
          Select Case As Long OSVersion
             Case %Win95
                'No need to repaint menubar - it always uses default text color
             Case %Win98
                If DialogIsActive Then RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
             Case Else  'WinME, WinNT, Win2k, WinXP --- I assume these OSes gray text for dialogs without focus
                If DialogIsActive Then RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
          End Select

       Case %WM_DISPLAYCHANGE
           NewColorMode = IIf&( CbWParam > 8, 1, 0)
           If NewColorMode <> CurrentDisplayMode Then
              CurrentDisplayMode = NewColorMode
              'Release old brushes
              DeleteObject hCustomBrush
              DeleteObject hCustomSunkenBrush
              DeleteObject hCustomBkBrush
              DeleteObject hCustomSunkenBkBrush
              DeleteObject hCustomFocusHLBrush
              DeleteObject hCustomFocusSelBrush
              'Get new brushes
              hCustomBrush         = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFace)
              hCustomSunkenBrush   = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFaceSunken)
              hCustomBkBrush       = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkHighlight)
              hCustomSunkenBkBrush = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkHighlightSunken)
              hCustomFocusHLBrush  = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFocusHighlight)
              hCustomFocusSelBrush = CreateSolidBrush( GetColorFor( CurrentDisplayMode).BkFocusSelect)
              'Force redraw of menu bar
              Dialog Set Color  CbHndl, GetColorFor( CurrentDisplayMode).TxDefault, GetColorFor( CurrentDisplayMode).BkFace
              RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_ERASE Or %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
           End If

       Case %WM_MEASUREITEM
           If CbWParam = 0 Then  'a menu is calling
              lpmis = CbLParam

              Array Scan MenuItemData(), From 1 To 4, =MkDwd$( @lpmis.itemID), To Offset
              Decr Offset  'Adjust for zero base
              zTxt = Parse$( MenuItemData( Offset).zTxt, $Tab, 1)

              hDC = GetDC( CbHndl)
                ncm.cbSize = Len( NONCLIENTMETRICS)
                SystemParametersInfo %SPI_GETNONCLIENTMETRICS, SizeOf( ncm), ByVal VarPtr(ncm), 0
                If Len(ncm.lfMenuFont) Then
                   hf = CreateFontIndirect(ncm.lfMenuFont)
                   If hf Then hf = SelectObject(hDC, hf)
                End If
                GetTextExtentPoint32 hDC, zTxt, Len( zTxt), SizeA
                @lpmis.itemHeight = ncm.iMenuHeight + 2
                Select Case As Long @lpmis.itemId
                   Case 0
                      'Separator
                      @lpmis.itemHeight = ncm.iMenuHeight \ 2
                   Case < %ODM_BASE_MENUBAR_ITEM_ID
                      'Submenu item
                      @lpmis.itemWidth  = sizeA.cx + MenuItemData( Offset).AccelWidth + %ODM_ACCEL_KEY_SPACING + %ODM_TEXT_OFFSET_FROM_ICON
                   Case Else
                      'Top level menu item
                      If MenuItemData( Offset).hIco Then
                         'Add margins for both right & left sides
                         @lpmis.itemWidth  = sizeA.cx + %ODM_MARGIN_SPACING + %ODM_MARGIN_SPACING
                      Else
                         'Add margins for both right & left sides
                         'Remove space for icon
                         @lpmis.itemWidth  = sizeA.cx - %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING + %ODM_MARGIN_SPACING
                      End If
                End Select
                If hf Then DeleteObject SelectObject(hDC, hf)
              ReleaseDC CbHndl, hDC
              Function = 1
           End If

       Case %WM_DRAWITEM
           If CbWParam = 0 Then           'if identifier is 0, message was sent by a menu
              lpdis = CbLParam

              If @lpdis.itemId Then
                 'Not a separator (they have .itemID=0)

                 Array Scan MenuItemData(), From 1 To 4, =MkDwd$( @lpdis.itemID), To Offset
                 Decr Offset  'Adjust for zero base
                 zTxt  = MenuItemData( Offset).zTxt
                 If (@lpdis.itemState And %ODS_CHECKED) Then
                    hIcon = MenuItemData( Offset).hCheckedIco
                 Else
                    hIcon = MenuItemData( Offset).hIco
                 End If

                 MaxAccelTxtWidth = MenuItemData( Offset).AccelWidth
                 Offset = 0  'We will reuse the Offset variable for positioning

                 If @lpdis.itemId >= %ODM_BASE_MENUBAR_ITEM_ID Then
                    'Top Level Menu
                    'Erase bottom border...
                    tRect = @lpdis.rcItem
                    Incr tRect.nBottom

                    Select Case As Long OSVersion
                       Case %Win95
                          Offset = -1  'Do not "click" a "button"
                          If (@lpdis.itemState And %ODS_SELECTED) Then
                             'Paint custom background...
                             FillRect @lpdis.hDC, tRect, hCustomBkBrush
                          Else
                             'Paint custom background...
                             FillRect @lpdis.hDC, tRect, hCustomBrush
                          End If
                       Case %WinXP
                          If (@lpdis.itemState And %ODS_SELECTED) Then
                             'Paint custom focus background...
                             FillRect @lpdis.hDC, tRect, hCustomFocusSelBrush
                             'Standard Windows XP focus framing
                             hf = SelectObject( @lpdis.hDC, CreatePen( %PS_SOLID, 0, GetColorFor( CurrentDisplayMode).TxDefault))
                             'Draw frame using custom colored pen
                             MoveToEx @lpdis.hDC, @lpdis.rcItem.nLeft, @lpdis.rcItem.nTop, ByVal 0
                             LineTo @lpdis.hDC, @lpdis.rcItem.nRight-1, @lpdis.rcItem.nTop
                             LineTo @lpdis.hDC, @lpdis.rcItem.nRight-1, @lpdis.rcItem.nBottom-1
                             LineTo @lpdis.hDC, @lpdis.rcItem.nLeft, @lpdis.rcItem.nBottom-1
                             LineTo @lpdis.hDC, @lpdis.rcItem.nLeft, @lpdis.rcItem.nTop
                             DeleteObject SelectObject( @lpdis.hDC, hf)
                          Else
                             Offset = -1  'Offset for text to move it when "button" is NOT "clicked"
                             'Paint custom background...
                             FillRect @lpdis.hDC, tRect, hCustomBrush
                          End If
                       Case %Win98
                          'Paint custom background...
                          FillRect @lpdis.hDC, tRect, hCustomBrush
                          If (@lpdis.itemState And %ODS_SELECTED) Then
                             'Standard Windows 98 focus edging
                             DrawEdge @lpdis.hDC, @lpdis.rcItem, %BDR_SUNKENOUTER, %BF_RECT
                             'Needed for our custom color to show top & left edges....
                             ' (If you change the custom color the following may not be necessary)
                             DrawEdge @lpdis.hDC, @lpdis.rcItem, %EDGE_SUNKEN, %BF_TOPLEFT
                          Else
                             Offset = -1  'Offset for text to move it when "button" is NOT "clicked"
                          End If
                       Case Else  'WinME, WinNT, Win2k --- Look like Win98???
                          'Paint custom background...
                          FillRect @lpdis.hDC, tRect, hCustomBrush
                          If (@lpdis.itemState And %ODS_SELECTED) Then
                             'Standard Windows 98 focus edging
                             DrawEdge @lpdis.hDC, @lpdis.rcItem, %BDR_SUNKENOUTER, %BF_RECT
                             'Needed for our custom color to show top & left edges....
                             ' (If you change the custom color the following may not be necessary)
                             DrawEdge @lpdis.hDC, @lpdis.rcItem, %EDGE_SUNKEN, %BF_TOPLEFT
                          Else
                             Offset = -1  'Offset for text to move it when "button" is NOT "clicked"
                          End If
                    End Select

                    If IsTrue DialogIsActive Or OSVersion = %Win95 Then
                       'Win95 does not gray text for disabled dialogs....
                       If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then
                          SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxGrayed
                       Else
                          SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxDefault
                       End If
                    Else
                       SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxGrayed
                    End If

                    'Set Border when at last top level menu item
                    If @lpdis.itemId = %ODM_BASE_MENUBAR_ITEM_ID + GetMenuItemCount( GetMenu( CbHndl)) - 1 Then
                       Border = @lpdis.rcItem.nRight
                       If RightEdge > 0 Then
                           tRect = @lpdis.rcItem
                           tRect.nLeft = Border
                           tRect.nRight = RightEdge
                           Incr tRect.nBottom
                           FillRect @lpdis.hDC, tRect, hCustomBrush
                       End If
                    End If
                 Else
                    'Sub-level Menu
                    If (@lpdis.itemState And %ODS_SELECTED) Then
                       'COLOR NOTE:
                       '   Windows automatically draws the sub-menu arrow icon even with ownerdrawn
                       '   status.  Windows uses the default colors for the arrow icon:
                       '        %COLOR_MENUTEXT? for unhighlighted items and
                       '        %COLOR_HIGHLIGHTTEXT for highlighted items
                       '   Setting the background highlight &/or text to different colors
                       '   may yield unsatisfactory results.
                       FillRect @lpdis.hDC, @lpdis.rcItem, hCustomBkBrush  'GetSysColorBrush( %COLOR_HIGHLIGHT)
                       If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then
                          SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxGrayed
                       Else
                          SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxHighlighted
                       End If
                    ElseIf (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then
                       FillRect @lpdis.hDC, @lpdis.rcItem, hCustomBrush    'GetSysColorBrush( %COLOR_MENU)
                       SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxGrayed
                    Else
                       FillRect @lpdis.hDC, @lpdis.rcItem, hCustomBrush    'GetSysColorBrush( %COLOR_MENU)
                       SetTextColor @lpdis.hDC, GetColorFor( CurrentDisplayMode).TxDefault
                    End If
                 End If
                 If (@lpdis.itemState And %ODS_CHECKED) Then
                    'Need to show depressed button effect
                    tRect = @lpdis.rcItem
                    tRect.nRight = tRect.nLeft + 19  'A total width of 20 pixels, 16 for icon, 4 for margins
                    DrawEdge @lpdis.hDC, tRect, %BDR_SUNKENOUTER, %BF_RECT
                    If CurrentDisplayMode = 0 Then
                       '256 color mode
                       'Needed for our custom color to show top & left edges....
                       ' (If you change the custom color the following may not be necessary)
                       DrawEdge @lpdis.hDC, tRect, %EDGE_SUNKEN, %BF_TOPLEFT
                    End If
                    Incr tRect.nTop
                    Incr tRect.nLeft
                    Decr tRect.nRight
                    Decr tRect.nBottom
                    If (@lpdis.itemState And %ODS_SELECTED) Then
                          FillRect @lpdis.hDC, tRect, hCustomSunkenBkBrush
                    Else
                          FillRect @lpdis.hDC, tRect, hCustomSunkenBrush
                    End If
                    If hIcon = 0 Then
                       'No user defined icon, so draw standard windows checkmark
                       'Get bitmap
                       hIcon = LoadBitMap( ByVal 0, ByVal %OBM_CHECK)
                       If hIcon <> 0 Then
                          'Make a brush colored same as text in temporary variable
                          hf = CreateSolidBrush( GetColorFor( CurrentDisplayMode).TxDefault)
                          'Draw checkmark in mono mode so it doesn't draw a background
                          Call DrawState(@lpdis.hDC, hf, 0&, hIcon, 0&, @lpdis.rcItem.nleft + 3, _
                                  @lpdis.rcItem.nTop + 4, 16, 16, %DST_BITMAP Or %DSS_MONO)
                          'Delete the bitmap when done, to avoid memory leaks!
                          DeleteObject hIcon
                          hIcon = 0
                          DeleteObject hf
                       End If
                    End If
                 End If

                 SetBkMode @lpdis.hDC, %TRANSPARENT

                 '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 ' Get menu item string and split up into ev. text and shortcut part
                 '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 strMenu2 = zTxt
                 If InStr(strMenu2, $Tab) Then       'if it has shortcut (Ctrl+X, etc.)
                    strMenu  = Trim$(Parse$(strMenu2, $Tab, 1))
                    strMenu2 = Trim$(Parse$(strMenu2, $Tab, 2))
                 Else
                    strMenu = Trim$(strMenu2)
                    strMenu2 = ""
                 End If

                 If Len( strMenu) <> 0 Then
                    tRect = @lpdis.rcItem
                    If Offset Then
                       tRect.nTop    = tRect.nTop    + Offset
                       tRect.nBottom = tRect.nBottom + Offset
                    End If
                    If @lpdis.itemId >= %ODM_BASE_MENUBAR_ITEM_ID Then
                       If hIcon Then
                          tRect.nLeft = @lpdis.rcItem.nleft + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING\2 + Offset*2  'Leave room for icons
                          DrawText @lpdis.hDC, ByVal StrPtr(strMenu), Len(strMenu), tRect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER Or %DT_CENTER
                          If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then hIcon = CopyImage( hIcon, %IMAGE_ICON, 16, 16, %LR_MONOCHROME)
                          DrawIconEx @lpdis.hDC, @lpdis.rcItem.nleft + %ODM_MARGIN_SPACING + Offset - 1, @lpdis.rcItem.nTop + 2 + Offset, _
                                     hIcon, 16, 16, 0, ByVal 0, %DI_NORMAL
                          If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then DeleteObject hIcon
                       Else
                          'When no icon in top level, adjust RECT
                          tRect.nLeft = @lpdis.rcItem.nleft + Offset*2  'Leave room for icons
                          DrawText @lpdis.hDC, ByVal StrPtr(strMenu), Len(strMenu), tRect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER Or %DT_CENTER
                       End If
                    Else
                       tRect.nLeft = @lpdis.rcItem.nleft + %ODM_ICON_IN_MENU_WIDTH + %ODM_MARGIN_SPACING + %ODM_TEXT_OFFSET_FROM_ICON 'Leave room for icons
                       DrawText @lpdis.hDC, ByVal StrPtr(strMenu), Len(strMenu), tRect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER
                       If Len(strMenu2) Then
                          tRect.nLeft = @lpdis.rcItem.nRight - MaxAccelTxtWidth
                          DrawText @lpdis.hDC, ByVal StrPtr(strMenu2), Len(strMenu2), tRect, %DT_LEFT Or %DT_NOCLIP Or %DT_SINGLELINE Or %DT_VCENTER
                       End If
                       'Draw icon if any...
                       If hIcon Then
                          If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then hIcon = CopyImage( hIcon, %IMAGE_ICON, 16, 16, %LR_MONOCHROME)
                          DrawIconEx @lpdis.hDC, @lpdis.rcItem.nleft + 1, @lpdis.rcItem.nTop + 2, _
                                     hIcon, 16, 16, 0, ByVal 0, %DI_NORMAL
                          If (@lpdis.itemState And (%ODS_DISABLED Or %ODS_GRAYED)) Then DeleteObject hIcon
                       End If
                    End If
                 End If
              Else
                 'Draw a separator
                 'Sub-level Menu
                 FillRect @lpdis.hDC, @lpdis.rcItem, hCustomBrush 'GetSysColorBrush(%COLOR_MENU)
                 tRect = @lpdis.rcItem
                 tRect.nTop  = tRect.nTop + (tRect.nBottom - tRect.nTop)\2
                 DrawEdge @lpdis.hDC, tRect, %EDGE_ETCHED, %BF_TOP
              End If
              Function = 1
           End If

       Case %WM_SIZING
          Select Case As Long CbWParam
             Case %WMSZ_BOTTOMRIGHT, %WMSZ_TOPRIGHT, %WMSZ_RIGHT
                'Get dimensions for dialog
                GetClientRect CbHndl, tRect
                'Save total width
                RightEdge = tRect.nRight + 4

                'Get new proposed size
                ptrRECT = CbLParam

                GetWindowRect CbHndl, tRect
                RightEdge = RightEdge + @ptrRECT.nRight - tRect.nRight
             Case %WMSZ_BOTTOMLEFT, %WMSZ_TOPLEFT, %WMSZ_LEFT
                'Get dimensions for dialog
                GetClientRect CbHndl, tRect
                'Save total width
                RightEdge = tRect.nRight + 4

                'Get new proposed size
                ptrRECT = CbLParam

                GetWindowRect CbHndl, tRect
                RightEdge = RightEdge + tRect.nLeft - @ptrRECT.nLeft
             Case Else
                'No action required for adjusting height only
          End Select

       Case %WM_SIZE
          If CbWParam = %SIZE_MAXIMIZED Then
             'Get dimensions for dialog
             GetClientRect CbHndl, tRect
             'Save total width
             RightEdge = tRect.nRight + 4

             RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
          End If

       Case %WM_NCLBUTTONDOWN
          'Mouse cursor is in non-client area
          If CbWParam = %HTMENU Then
             'If last item with focus has not been cleared, clear it
             If hTimer Then
                KillTimer CbHndl, hTimer
                hTimer = 0
                FocusItem = 0
             End If
          End If

       Case %WM_NCMOUSEMOVE
          'Mouse cursor is in non-client area
          If CbWParam = %HTMENU Then
             Select Case As Long OSVersion
                Case %Win95
                   'No focus highlighting for Win95
                   Exit Function
                Case %Win98
                   'Maintain focus highlighting whether dialog is active or not
                Case Else 'WinME, WinNT, Win2k, WinXP
                   'Not sure what the standard focus highlighting behavior is
                   'when the dialog is not active.

                   'Add focus highlighting only if dialog is active...
                   If IsFalse DialogIsActive Then Exit Function
             End Select
             'If mouse cursor is over the menubar, check which menubar item is under the cursor
             hMenu = GetMenu( CbHndl)
             For I = 0 To GetMenuItemCount( hMenu) - 1
                GetMenuItemRect CbHndl, hMenu, I, tRect
                If PtInRect( tRect, LoWrd( CbLParam), HiWrd( CbLParam)) Then

                   'Check if mouse is still over item with focus
                   If %ODM_BASE_MENUBAR_ITEM_ID +I = FocusItem Then Exit For

                   K = GetMenuState( hMenu, I, %MF_BYPOSITION)

                   'If last item with focus has not been cleared, clear it
                   If hTimer Then
                      KillTimer CbHndl, hTimer
                      hTimer = 0
                      Array Scan MenuItemData(), From 1 To 4, =MkDwd$( FocusItem), To Offset
                      hIcon = MenuItemData( Offset-1).hIco
                      'Get RECT of menu item that had focus
                      GetMenuItemRect CbHndl, hMenu, FocusItem - %ODM_BASE_MENUBAR_ITEM_ID, FocusRect
                      If (LoByt( LoWrd( K)) And (%MF_DISABLED Or %MF_GRAYED)) Then hIcon = CopyImage( hIcon, %IMAGE_ICON, 16, 16, %LR_MONOCHROME)
                      mRestoreMenuItem
                      If (LoByt( LoWrd( K)) And (%MF_DISABLED Or %MF_GRAYED)) Then DeleteObject hIcon
                   End If

                   'Set focus and remember bounding RECT
                   FocusItem = %ODM_BASE_MENUBAR_ITEM_ID + I
                   GetMenuItemRect CbHndl, hMenu, I, FocusRect

                   Array Scan MenuItemData(), From 1 To 4, =MkDwd$( FocusItem), To Offset
                   hIcon = MenuItemData( Offset-1).hIco
                   If (LoByt( LoWrd( K)) And (%MF_DISABLED Or %MF_GRAYED)) Then hIcon = CopyImage( hIcon, %IMAGE_ICON, 16, 16, %LR_MONOCHROME)
                   mHighlightMenuItem
                   If (LoByt( LoWrd( K)) And (%MF_DISABLED Or %MF_GRAYED)) Then DeleteObject hIcon

                   hTimer = SetTimer (CbHndl, 1, 100, ByVal %Null)
                   Exit For
                End If
             Next
          End If

       Case %WM_TIMER
          GetCursorPos pt
          GetMenuItemRect CbHndl, GetMenu( CbHndl), FocusItem - %ODM_BASE_MENUBAR_ITEM_ID, FocusRect
          If PtInRect( FocusRect, pt.x, pt.y) Then
             'Still has focus
          Else
             KillTimer CbHndl, hTimer
             hTimer = 0
             Array Scan MenuItemData(), From 1 To 4, =MkDwd$( FocusItem), To Offset
             hIcon = MenuItemData( Offset-1).hIco
             K = GetMenuState( GetMenu( CbHndl), FocusItem - %ODM_BASE_MENUBAR_ITEM_ID, %MF_BYPOSITION)
             If (LoByt( LoWrd( K)) And (%ODS_DISABLED Or %ODS_GRAYED)) Then hIcon = CopyImage( hIcon, %IMAGE_ICON, 16, 16, %LR_MONOCHROME)
             mRestoreMenuItem
             If (LoByt( LoWrd( K)) And (%ODS_DISABLED Or %ODS_GRAYED)) Then DeleteObject hIcon
             FocusItem = 0
          End If

       Case %WM_COMMAND
           Select Case CbCtl
               Case %IDM_FILE_OPEN
                   hMenu = GetMenu( CbHndl)
                   hSubMenu = GetSubMenu( hMenu, 0)  'File sub-menu
                   Menu Get State hSubMenu, ByCmd %IDM_FILE_OPEN To Offset 'Dummy variable
                   Offset = Offset Xor %MF_CHECKED
                   Menu Set State hSubMenu, ByCmd %IDM_FILE_OPEN, Offset
               Case %IDM_FILE_SAVE
                   MsgBox "%IDM_FILE_SAVE=" + Format$(%IDM_FILE_SAVE)
               Case %IDM_FILE_EXIT
                   MsgBox "%IDM_FILE_EXIT=" + Format$(%IDM_FILE_EXIT)
               Case %IDM_EDIT_CUT
                   MsgBox "%IDM_EDIT_CUT=" + Format$(%IDM_EDIT_CUT) + $CrLf + _
                          "Disabled Copy & Grayed Paste!"
                   hMenu = GetMenu( CbHndl)
                   hSubMenu = GetSubMenu( hMenu, 1)  'Edit sub-menu
                   Menu Set State hSubMenu, ByCmd %IDM_EDIT_COPY, %MF_DISABLED
                   Menu Set State hSubMenu, ByCmd %IDM_EDIT_PASTE, %MF_GRAYED
               Case %IDM_EDIT_COPY
                   MsgBox "%IDM_EDIT_COPY=" + Format$(%IDM_EDIT_COPY) + $CrLf + _
                          "Disabled Double Nested Test Sub-Menu!"
                   hMenu = GetMenu( CbHndl)
                   hSubMenu = GetSubMenu( hMenu, 1)    'Edit sub-menu
                   hSubMenu = GetSubMenu( hSubMenu, 4) 'Sub-Menu Test sub-menu
                   Menu Set State hSubMenu, 3, %MF_DISABLED

                   'If you modify the top level menu, you must call RedrawWindow to force a repaint
                   Menu Set State hMenu, 1, %MF_GRAYED
                   Menu Set State hMenu, 3, %MF_GRAYED
                   RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
               Case %IDM_EDIT_PASTE
                   MsgBox "%IDM_EDIT_PASTE=" + Format$(%IDM_EDIT_PASTE) + $CrLf + _
                          "Enabled Double Nested Test Sub-Menu!"
                   hMenu = GetMenu( CbHndl)
                   hSubMenu = GetSubMenu( hMenu, 1)    'Edit sub-menu
                   hSubMenu = GetSubMenu( hSubMenu, 4) 'Sub-Menu Test sub-menu
                   Menu Set State hSubMenu, 3, %MF_ENABLED
               Case %IDM_HELP_HELPTOPICS
                   MsgBox "%IDM_HELP_HELPTOPICS=" + Format$(%IDM_HELP_HELPTOPICS)
               Case %IDM_HELP_ABOUT
                   MsgBox "%IDM_HELP_ABOUT=" + Format$(%IDM_HELP_ABOUT)
               Case %IDM_EDIT_SUB_COOL
                   MsgBox "%IDM_EDIT_SUB_COOL=" + Format$(%IDM_EDIT_SUB_COOL) + $CrLf + _
                          "Enabled Copy & Paste!"
                   hMenu = GetMenu( CbHndl)
                   hSubMenu = GetSubMenu( hMenu, 1)  'Edit sub-menu
                   Menu Set State hSubMenu, ByCmd %IDM_EDIT_COPY, %MF_ENABLED
                   Menu Set State hSubMenu, ByCmd %IDM_EDIT_PASTE, %MF_ENABLED

                   'If you modify the top level menu, you must call RedrawWindow to force a repaint
                   Menu Set State hMenu, 1, %MF_ENABLED
                   Menu Set State hMenu, 3, %MF_ENABLED
                   RedrawWindow CbHndl, ByVal 0, ByVal 0, %RDW_INVALIDATE Or %RDW_FRAME Or %RDW_UPDATENOW Or %RDW_ALLCHILDREN
               Case %IDM_EDIT_SUB_DARE
                   MsgBox "%IDM_EDIT_SUB_DARE=" + Format$(%IDM_EDIT_SUB_DARE)
           End Select

       Case %WM_DESTROY
           If hTimer Then KillTimer CbHndl, hTimer
           DeleteObject hCustomBrush
           DeleteObject hCustomSunkenBrush
           DeleteObject hCustomBkBrush
           DeleteObject hCustomSunkenBkBrush
           DeleteObject hCustomFocusHLBrush
           DeleteObject hCustomFocusSelBrush
   End Select

End Function
'--------------------------------------------------------------------------------


'--------------------------------------------------------------------------------
'   ** Dialogs **
'--------------------------------------------------------------------------------
Function ShowDIALOG1(ByVal hParent As Dword) As Long
    Local lRslt As Long

    Local hDlg As Dword

    Dialog New hParent, "OwnerDrawMenu Example Including Top Level Menu", 92, _
        98, 302, 172, %WS_OVERLAPPED Or %WS_THICKFRAME Or %WS_CAPTION Or _
        %WS_SYSMENU Or %WS_MINIMIZEBOX Or %WS_MAXIMIZEBOX Or %WS_VISIBLE Or _
        %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, %WS_EX_WINDOWEDGE Or _
        %WS_EX_LEFT Or %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg

    'It's necessary to add a dummy button to force the menu command
    'accelerators ( '&F'ile ) to work.
    Control Add Button, hDlg, 100, "Dummy Button", 0, 0, 0, 0

    AttachMENU1 hDlg

    AttachACCELERATOR1 hDlg

    Dialog Set Color hDlg, GetColorFor( CurrentDisplayMode).TxDefault, GetColorFor( CurrentDisplayMode).BkFace

    Dialog Show Modal hDlg, Call ShowDIALOG1Proc To lRslt

    Function = lRslt

End Function
'--------------------------------------------------------------------------------
